from flask import Flask,render_template,request,session,redirect,url_for
from app import key,bluetooth_connect,data
from models.database import db_session
from hashlib import sha256
from datetime import datetime
import bluetooth,sqlite3
import cgi,mysql.connector

app = Flask(__name__)
app.secret_key = key.SECRET_KEY

blcont = bluetooth_connect.BLcont()
data = data.Netdata()


@app.route("/")
@app.route("/mirs")
def mirs():
    devices = bluetooth.discover_devices(lookup_names=True)
    found_device = list()
    found_address = list()
    device_id = list()
    found_device.clear()
    found_address.clear()
    device_id.clear()
    f_name = ""
    f_addr = ""
    count = 0
    h_name = data.h_name

    con = sqlite3.connect('./models/loginid.db')
    cur = con.cursor()

    sql = "drop table if exists founddevice;"
    cur.execute(sql)

    sql = "create table founddevice(found_name text , found_address text);"
    cur.execute(sql)

    for addr , name in devices:
        if "" in addr:
            f_addr = addr
            f_name = name
            sql = "insert into founddevice values('" + f_name + "' , '" + f_addr + "')"
            cur.execute(sql)
            con.commit()
            device_id.append(count)
            count += 1

    sql = "select * from founddevice"
    cur.execute(sql)
    for word in cur:
        print(word[0], end = ' ')
        print(word[1])
        found_device.append(word[0])
        found_address.append(word[1])

    con.close()

    return render_template("mirs.html" , device_id = device_id , found_device = found_device , found_address =found_address , h_name = h_name)


@app.route("/login" , methods = ["post"])
def login():
    foundid = ""
    loginpass = ""
    device_name = list()
    device_address = list()
    device_pass = list()
    count = 0

    con = sqlite3.connect("./models/loginid.db")
    cur =con.cursor()

    sql = "select * from loginkey"
    cur.execute(sql)
    for word in cur:
        print(word[0] , end = ' ')
        device_name.append(word[0])
        print(word[1] , end = ' ')
        device_address.append(word[1])
        print(word[2])
        device_pass.append(word[2])

    con.close()

    try:
        foundid = request.form["select_device"]
    except Exception as e:
        print(e)
        
    try:
        loginpass = request.form["pass"]
    except Exception as e:
        print(e)

    print(foundid)
    print(loginpass)

    for word in device_name:
        if foundid == device_address[count]:
            if loginpass == device_pass[count]:
                data.h_name = "MIRS"
                data.dv_name = device_name[count]
                data.dv_addr = device_address[count]
                data.dv_pass = device_pass[count]
                return redirect(url_for("mirs_home"))
        count += 1

    data.h_name = "FAIL"
    return redirect(url_for("mirs"))


@app.route("/mirs_home")
def mirs_home():
    device_name = data.dv_name
    device_address = data.dv_addr
    device_pass = data.dv_pass
    h_name = data.h_name
    port = 1

    blcont.blconnect(device_address , port)

    return render_template("mirs_home.html" , h_name = h_name , device_name = device_name , device_address = device_address , device_pass = device_pass)


@app.route("/mirs_home" , methods = ["post"])
def mirs_act():
    if request.form['act'] == 'アピール':
        print("Appeal")
        blcont.blsend("1" , blcont.s)
    if  request.form['act'] == '乗車':
        print("Ride on")
        blcont.blsend("2" , blcont.s)
    if  request.form['act'] == '診察室へ':
        print("Start up")
        blcont.blsend("3" , blcont.s)
    if  request.form['act'] == '降車':
        print("Take Down")
        blcont.blsend("4" , blcont.s)
    if  request.form['act'] == '注射':
        print("Injection")
        blcont.blsend("5" , blcont.s)
    if  request.form['act'] == '待合室へ':
        print("Get Back")
        blcont.blsend("6" , blcont.s)
    if  request.form['act'] == '終了':
        print("Goodbye")
        blcont.blsend("7" , blcont.s)
    if  request.form['act'] == '緊急停止':
        print("Error")
        blcont.blsend("9" , blcont.s)

    return redirect(url_for("mirs_home"))


@app.route("/forget")
def forget():
    return render_template("forget.html")


@app.route("/forget" , methods = ["post"])
def change_pass():
    count = 0
    device_name = list()
    device_address = list()
    device_pass = list()
    device_code = list()
    writtencode = request.form["code"]
    newpass = request.form["new_password"]

    con = sqlite3.connect("./models/loginid.db")
    cur =con.cursor()

    sql = "select * from loginkey"
    cur.execute(sql)
    for word in cur:
        print(word[0] , end = ' ')
        device_name.append(word[0])
        print(word[1] , end = ' ')
        device_address.append(word[1])
        print(word[2] , end = '')
        device_pass.append(word[2])
        print(word[3])
        device_code.append(word[3])

        if  writtencode == device_code[count]:
            print(newpass)
            if device_address[count] != None:
                print(device_address[count])
                sql = "update loginkey set password = '" + newpass + "' where device_address = '" + device_address[count] + "'"
                cur.execute(sql)
                con.commit()
                con.close()
                return redirect(url_for("mirs"))
        count += 1

    con.close()
    return render_template("forget.html" , status = 'wrong_pass')


@app.route("/logout")
def logout():
    blcont.s.close()
    return redirect(url_for("mirs"))


@app.route("/change")
def change():
    return render_template("change.html")


@app.route("/change" , methods = ["post"])
def change_password():
    count = 0
    device_name = list()
    device_address = list()
    device_pass = list()
    device_code = list()
    oldpass = request.form["pass"]
    newpass = request.form["new_password"]

    con = sqlite3.connect("./models/loginid.db")
    cur =con.cursor()

    sql = "select * from loginkey"
    cur.execute(sql)
    for word in cur:
        print(word[0] , end = ' ')
        device_name.append(word[0])
        print(word[1] , end = ' ')
        device_address.append(word[1])
        print(word[2] , end = '')
        device_pass.append(word[2])
        print(word[3])
        device_code.append(word[3])

        if  oldpass == device_pass[count]:
            print(newpass)
            if data.dv_addr == device_address[count]:
                print(device_address[count])
                sql = "update loginkey set password = '" + newpass + "' where device_address = '" + device_address[count] + "'"
                cur.execute(sql)
                con.commit()
                con.close()
                return redirect(url_for("mirs_home"))
        count += 1

    con.close()
    return render_template("change.html" , status = "wrong_pass")



if __name__ == "__main__":
    app.run(debug = True)